/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.StateCommon
 *  fire.pb.common.SCommon
 *  fire.pb.course.CourseManager
 *  fire.pb.main.ConfigManager
 *  fire.pb.util.DateValidate
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.FriendBean
 *  xbean.FriendGroups
 *  xbean.FriendlyDegreesLimit
 *  xbean.MenstorAndApprent
 *  xtable.Friends
 *  xtable.Menstor
 */
package fire.pb.friends;

import fire.pb.PropRole;
import fire.pb.StateCommon;
import fire.pb.common.SCommon;
import fire.pb.course.CourseManager;
import fire.pb.friends.InfoBean;
import fire.pb.friends.SFriendsOnline;
import fire.pb.friends.SUpdateFriendLevel;
import fire.pb.main.ConfigManager;
import fire.pb.util.DateValidate;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.FriendBean;
import xbean.FriendGroups;
import xbean.FriendlyDegreesLimit;
import xbean.MenstorAndApprent;
import xtable.Friends;
import xtable.Menstor;

public class FriendHelper {
    public static final int FRIEND_NUM_LIMIT = 100;
    public static final int FRIENDLYDEGREES_INIT = 1;
    public static final short MARRY = 1;
    public static final short SWORN = 2;
    public static final short MASTER = 4;

    public static boolean isBothwayFriend(FriendGroups friendGroups1, long roleId1, FriendGroups friendGroups2, long roleId2) {
        if (friendGroups1 == null || friendGroups2 == null) {
            return false;
        }
        return friendGroups1.getFriendmap().get(roleId2) != null && friendGroups2.getFriendmap().get(roleId1) != null;
    }

    public static boolean isBothwayFriend(long roleId1, long roleId2) {
        FriendGroups friendGroups1 = Friends.select((Long)roleId1);
        FriendGroups friendGroups2 = Friends.select((Long)roleId2);
        return FriendHelper.isBothwayFriend(friendGroups1, roleId1, friendGroups2, roleId2);
    }

    public static int getFriendlyDegrees(FriendGroups myFriendGroups, long friendRoleId) {
        FriendBean friendBean;
        if (myFriendGroups != null && (friendBean = (FriendBean)myFriendGroups.getFriendmap().get(friendRoleId)) != null) {
            return friendBean.getFriendlydegrees();
        }
        return -1;
    }

    public static int getFriendlyDegrees(long myRoleId, long friendRoleId) {
        FriendBean friendBean;
        Map friendMap = Friends.selectFriendmap((Long)myRoleId);
        if (friendMap != null && (friendBean = (FriendBean)friendMap.get(friendRoleId)) != null) {
            return friendBean.getFriendlydegrees();
        }
        return -1;
    }

    public static int addFriendlyDegrees(FriendGroups myFriendGroups, long myRoleId, long friendRoleId, int addValue) {
        if (myFriendGroups == null) {
            return 0;
        }
        FriendBean friendBean = (FriendBean)myFriendGroups.getFriendmap().get(friendRoleId);
        if (friendBean != null) {
            int nowValue = friendBean.getFriendlydegrees();
            if (nowValue + addValue > FriendHelper.getFriendlyDegreesMax()) {
                addValue = Math.max(FriendHelper.getFriendlyDegreesMax() - nowValue, 0);
            }
            friendBean.setFriendlydegrees(nowValue += addValue);
            SUpdateFriendLevel send = new SUpdateFriendLevel();
            send.friendid = friendRoleId;
            send.currentfriendlevel = nowValue;
            Procedure.psendWhileCommit((long)myRoleId, (Protocol)send);
            if (addValue > 0) {
                FriendHelper.onAddFriendlyDegrees(myRoleId, nowValue);
            }
            return addValue;
        }
        return 0;
    }

    private static void onAddFriendlyDegrees(long roleId, int nowValue) {
        CourseManager.checkAchieveCourse((long)roleId, (int)26, (int)500, (int)0, (int)nowValue);
        CourseManager.checkAchieveCourse((long)roleId, (int)26, (int)1000, (int)0, (int)nowValue);
    }

    public static void fixFriendlyDegreesLimit(FriendGroups myFriendGroups) {
        FriendlyDegreesLimit limit;
        long now = System.currentTimeMillis();
        if (!DateValidate.inTheSameDay((long)now, (long)(limit = myFriendGroups.getFriendlydegreeslimit()).getResettime())) {
            limit.getTodayfriendlydegreesmap().clear();
            limit.setResettime(now);
        }
    }

    public static int getTodayFriendlyDegrees(FriendGroups myFriendGroups, long friendRoleId) {
        FriendHelper.fixFriendlyDegreesLimit(myFriendGroups);
        Integer ret = (Integer)myFriendGroups.getFriendlydegreeslimit().getTodayfriendlydegreesmap().get(friendRoleId);
        return ret != null ? ret : 0;
    }

    public static void addTodayFriendlyDegrees(FriendGroups myFriendGroups, long friendRoleId, int addValue) {
        FriendHelper.fixFriendlyDegreesLimit(myFriendGroups);
        int value = FriendHelper.getTodayFriendlyDegrees(myFriendGroups, friendRoleId) + addValue;
        myFriendGroups.getFriendlydegreeslimit().getTodayfriendlydegreesmap().put(friendRoleId, value);
    }

    public static int getRelation(long srcRoleId, long friendId) {
        int relation = 0;
        long marryRoleId = 0L;
        long masterId = 0L;
        MenstorAndApprent master = Menstor.select((Long)srcRoleId);
        if (master != null) {
            masterId = master.getMenstorid();
        }
        if (marryRoleId == friendId) {
            relation = 1;
        }
        if (masterId == friendId) {
            relation += 4;
        }
        return relation;
    }

    public static int getRelation(long roleid, long marryRoleId, long swordId, long masterId) {
        int relation = 0;
        if (marryRoleId == roleid) {
            relation = 1;
        }
        if (masterId == roleid) {
            relation += 4;
        }
        return relation;
    }

    public static InfoBean toInfoBean(long srcRoleId, long friendId) {
        InfoBean friendInfoBean = new InfoBean();
        boolean onlineFlag = StateCommon.isOnlineBuffer((long)friendId);
        boolean flag = onlineFlag;
        PropRole friendAttr = new PropRole(friendId, true);
        friendInfoBean.roleid = friendId;
        friendInfoBean.name = friendAttr.getName();
        friendInfoBean.rolelevel = (short)(friendAttr.getLevel() + friendAttr.getzhuansheng() * 1000);
        friendInfoBean.school = (byte)friendAttr.getSchool();
        friendInfoBean.shape = friendAttr.getShape();
        friendInfoBean.online = (byte)(flag ? 1 : 0);
        friendInfoBean.relation = (short)FriendHelper.getRelation(srcRoleId, friendId);
        friendInfoBean.factionid = friendAttr.getClanKey();
        long cfr_ignored_0 = friendInfoBean.factionid;
        return friendInfoBean;
    }

    public static InfoBean toInfoBean(long friendId) {
        InfoBean friendInfoBean = new InfoBean();
        boolean onlineFlag = StateCommon.isOnlineBuffer((long)friendId);
        boolean flag = onlineFlag;
        PropRole friendAttr = new PropRole(friendId, true);
        friendInfoBean.roleid = friendId;
        friendInfoBean.name = friendAttr.getName();
        friendInfoBean.rolelevel = (short)(friendAttr.getLevel() + friendAttr.getzhuansheng() * 1000);
        friendInfoBean.school = (byte)friendAttr.getSchool();
        friendInfoBean.shape = friendAttr.getShape();
        friendInfoBean.online = (byte)(flag ? 1 : 0);
        friendInfoBean.factionid = friendAttr.getClanKey();
        long cfr_ignored_0 = friendInfoBean.factionid;
        return friendInfoBean;
    }

    public static InfoBean toInfoBean(long roleId, long marryRoleId, long swordId, long masterId) {
        InfoBean friendInfoBean = new InfoBean();
        boolean onlineFlag = StateCommon.isOnlineBuffer((long)roleId);
        boolean flag = onlineFlag;
        PropRole friendAttr = new PropRole(roleId, true);
        friendInfoBean.roleid = roleId;
        friendInfoBean.name = friendAttr.getName();
        friendInfoBean.rolelevel = (short)(friendAttr.getLevel() + friendAttr.getzhuansheng() * 1000);
        friendInfoBean.school = (byte)friendAttr.getSchool();
        friendInfoBean.shape = friendAttr.getShape();
        friendInfoBean.online = (byte)(flag ? 1 : 0);
        friendInfoBean.relation = (short)FriendHelper.getRelation(roleId, marryRoleId, swordId, masterId);
        friendInfoBean.factionid = friendAttr.getClanKey();
        long cfr_ignored_0 = friendInfoBean.factionid;
        return friendInfoBean;
    }

    public static void notifyFriendStatus(final boolean online, final long srcRoleId) {
        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

            public boolean process() {
                FriendGroups groups = Friends.select((Long)srcRoleId);
                if (groups == null) {
                    return false;
                }
                SFriendsOnline send = new SFriendsOnline();
                send.roleid = srcRoleId;
                send.online = online ? (byte)1 : 0;
                ArrayList<Long> sendList = new ArrayList<Long>();
                Iterator iterator = groups.getFriendmap().keySet().iterator();
                while (iterator.hasNext()) {
                    long roleId = (Long)iterator.next();
                    FriendGroups temp = Friends.select((Long)roleId);
                    if (temp == null || temp.getFriendmap().get(srcRoleId) == null) continue;
                    sendList.add(roleId);
                }
                if (sendList.size() > 0) {
                    Procedure.psendWhileCommit(sendList, (Protocol)send);
                }
                return true;
            }
        });
    }

    public static Integer getCommonConf(int id) {
        SCommon conf;
        TreeMap confs = ConfigManager.getInstance().getConf(SCommon.class);
        if (confs != null && (conf = (SCommon)confs.get(id)) != null) {
            return Integer.parseInt(conf.getValue());
        }
        return null;
    }

    public static int getFriendlyDegreesDayMax() {
        Integer value = FriendHelper.getCommonConf(343);
        if (value == null) {
            value = 100;
        }
        return value;
    }

    public static int getFriendlyDegreesMax() {
        Integer value = FriendHelper.getCommonConf(342);
        if (value == null) {
            value = 9999;
        }
        return value;
    }

    public static int getFriendlyDegreesMaxOfBattle() {
        Integer value = FriendHelper.getCommonConf(340);
        if (value == null) {
            value = 9999;
        }
        return value;
    }

    public static int getFriendlyDegreesMaxOfGiveGift() {
        Integer value = FriendHelper.getCommonConf(341);
        if (value == null) {
            value = 9999;
        }
        return value;
    }
}

